import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
import { Service } from '@s-ui/domain';
export var ProcessQueuedTaskService = /*#__PURE__*/function (_Service) {
  _inheritsLoose(ProcessQueuedTaskService, _Service);
  function ProcessQueuedTaskService(_ref) {
    var _this;
    var config = _ref.config,
      taskRepository = _ref.taskRepository;
    _this = _Service.call(this) || this;
    _this._config = config;
    _this._taskRepository = taskRepository;
    return _this;
  }
  var _proto = ProcessQueuedTaskService.prototype;
  _proto.execute = function execute() {
    var tasks = this._taskRepository.getNonStartedTasks();
    var updatedTasks = tasks.map(function (task) {
      var queuedWork = task.getRunnableWork();
      if (queuedWork.length === 0) {
        task.markAsCompleted();
        return task;
      }
      task.markAsInProgress();
      queuedWork[0].execute();
      return task;
    });
    return this._taskRepository.updateTasks(updatedTasks);
  };
  return ProcessQueuedTaskService;
}(Service);