import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
import { ValueObject } from '@s-ui/domain';
export var WorkListTaskValueObject = /*#__PURE__*/function (_ValueObject) {
  _inheritsLoose(WorkListTaskValueObject, _ValueObject);
  function WorkListTaskValueObject() {
    return _ValueObject.apply(this, arguments) || this;
  }
  var _proto = WorkListTaskValueObject.prototype;
  _proto.getWork = function getWork() {
    return this._work;
  };
  _proto.setWork = function setWork(work) {
    this._work = work;
  };
  _proto.getById = function getById(idValueObject) {
    return this._work.find(function (work) {
      return work._id.get() === idValueObject.get();
    });
  };
  _proto.push = function push(work) {
    this._work.push(work);
  };
  _proto.countVisibleWork = function countVisibleWork() {
    return this._work.filter(function (work) {
      return work.isVisible();
    }).length;
  };
  _proto.hasInProgressWork = function hasInProgressWork() {
    return this._work.some(function (work) {
      return work.isInProgress();
    });
  };
  _proto.getRunnableWork = function getRunnableWork() {
    var _this = this;
    return this._work.filter(function (work) {
      return work.isQueued() && work.areDependenciesMet(_this);
    });
  };
  _proto.toJSON = function toJSON() {
    return this._work.map(function (work) {
      return work.toJSON();
    });
  };
  return WorkListTaskValueObject;
}(ValueObject);