import _extends from "@babel/runtime/helpers/esm/extends";
import { TaskEntitiesFactory } from '../Entities/factory.js';
import { StatusTaskValueObject } from './StatusTaskValueObject.js';
import { WorkListTaskValueObject } from './WorkListTaskValueObject.js';
import { WorkResultTaskValueObject } from './WorkResultTaskValueObject.js';
export var TaskValueObjectsFactory = function TaskValueObjectsFactory() {};
TaskValueObjectsFactory.statusTaskValueObject = function (config, status) {
  if (status === void 0) {
    status = config.get('AVAILABLE_STATUS').QUEUED;
  }
  var statusValueObject = new StatusTaskValueObject({
    config: config,
    value: status
  });
  statusValueObject.validate();
  return statusValueObject;
};
TaskValueObjectsFactory.workListTaskValueObject = function (config, work, taskId) {
  if (work === void 0) {
    work = [];
  }
  if (taskId === void 0) {
    taskId = null;
  }
  var workEntities = work.map(function (workItem) {
    return TaskEntitiesFactory.workTaskEntity(_extends({
      config: config,
      taskId: taskId
    }, workItem));
  });
  return new WorkListTaskValueObject({
    work: workEntities
  });
};
TaskValueObjectsFactory.workResultTaskValueObject = function (result) {
  return new WorkResultTaskValueObject({
    result: result
  });
};