import { useCallback, useEffect } from 'react';
import useContext from './useContext.js';
var displayCloseAlert = function displayCloseAlert(e) {
  e.preventDefault();
  e.returnValue = '';
};
var useBeforeUnloadEffect = function useBeforeUnloadEffect(_ref) {
  var isVisible = _ref.isVisible;
  var _useContext = useContext(),
    domain = _useContext.domain,
    getState = _useContext.getState;
  var state = getState();
  var config = domain.get('config');
  var _displayCloseAlert = useCallback(function (e) {
    var hasInProgressTasks = state.tasks.filter(function (task) {
      return task.status === config.get('AVAILABLE_STATUS').IN_PROGRESS;
    }).length > 0;
    if (hasInProgressTasks) {
      displayCloseAlert(e);
    }
  }, [config, state]);
  useEffect(function () {
    if (isVisible === false) return;
    window.addEventListener('beforeunload', _displayCloseAlert);
    return function () {
      window.removeEventListener('beforeunload', _displayCloseAlert);
    };
  }, [_displayCloseAlert, isVisible]);
};
export default useBeforeUnloadEffect;